
//  NamesFromSourceFile.java  (c) Kari Laitinen

//  http://www.naturalprogramming.com

//  2014-05-05  File created.
//  2015-01-02  Last modification.

import java.io.* ;
import java.util.* ;


import java.util.regex.Matcher;
import java.util.regex.Pattern;

class NamesFromSourceFile
{
   public static void main( String[] not_in_use )
   {
      Scanner keyboard = new Scanner( System.in ) ;

      String  file_to_check  =  "Testfile.java" ;


      Pattern identifier_name_pattern

         //= Pattern.compile("[A-Za-z_][A-Za-z0-9_]*" ); // traditional name

         //= Pattern.compile( "[A-Za-z]+[_][A-Za-z_]+" ) ; // name with underscores

         //= Pattern.compile( "[a-z]{12,}" ) ; // name with at least 12 lowercase letters

         //= Pattern.compile( "[A-Za-z]+[_][A-Za-z_]+|[a-z]{12,}" ) ; // OR with above two

         = Pattern.compile( "(\\b[a-z]*[A-Z][a-z]{3,}[A-Za-z]*\\b)" + "|" // camelcased, word boundaries
                          + "(\\b[A-Za-z]+[_][A-Za-z_]+\\b)" + "|"        //  name_with_underscores
                          + "(\\b[a-z]{12,}\\b)" ) ; // name with at least 12 lowercase letters


      // We'll store the names (identifiers) that we find into the
      // following HashSet. A HashSet cannot contain duplicate elements.

      HashSet<String> found_names = new HashSet<String>() ;


      try
      {
         BufferedReader buffered_reader =
                      new BufferedReader( new FileReader( file_to_check ) ) ;

         int line_counter  =  0 ;
         boolean  end_of_file_encountered  =  false ;

         while ( end_of_file_encountered  ==  false )
         {
            String text_line_from_file  =  buffered_reader.readLine() ;

            if ( text_line_from_file  ==  null )
            {
               end_of_file_encountered  =  true ;
            }
            else
            {
               //System.out.print( text_line_from_file  +  "\n" ) ;
               //line_counter  ++  ;
               
               Matcher name_matcher =
                        identifier_name_pattern.matcher( text_line_from_file ) ;

               while ( name_matcher.find() )
               {
                  String found_name = name_matcher.group() ;
      
                  found_names.add( found_name ) ;
               }
            }
         }

         buffered_reader.close() ;
         //System.out.print( "\n  " + line_counter + " lines processed." ) ;
      }
      catch ( FileNotFoundException  caught_file_not_found_exception )
      {
         System.out.print( "\n \"" + file_to_check + "\" not found.\n" ) ;
      }
      catch ( IOException  caught_io_exception )
      {
         System.out.print( "\n\n  File reading error.  \n" ) ;
      }

      System.out.print( "\n The following names were found in " + file_to_check
                     +  " \n" ) ;

      for ( String name_to_print : found_names )
      {
         System.out.print( "\n   " + name_to_print ) ;
      }

      System.out.print( "\n" ) ;
   }
}

/*  NOTES:

Useful pages related to this program:

http://docs.oracle.com/javase/7/docs/api/java/util/regex/Pattern.html

http://docs.oracle.com/javase/7/docs/api/java/util/regex/Matcher.html

*/
